VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDecryptXOR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'cDecryptXOR - XOR decoding IStream implementation
'Author: Kenneth Srling
'Purpose: This class acts as a decrypting filter to put between
'objects which communicate through IStream Pointers
'
'NOTE: This IStream implementation is designed to be read from,
'not written to. It must be assigned a (encrypted) source IStream
'before being handed to an IStream reader.

'NOTE! NOTE! NOTE!
' This is unfinished work. It hasn't been properly tested or debugged yet.
' Use at your own risk and proceed with extreme caution!

Option Explicit
Const MODULE = APPLICATION & ".cDecryptXOR"
Implements olelib2.IStream

Private m_bCryptKey() As Byte
Private m_lngCryptIndex As Long
'These are in ULARGE_INTEGER format. Mostly,
'The integral value will reside in the fractional part
Private m_cyStartOffset As Currency
Private m_cyEndOffset As Currency
Private m_cyCurOffset As Currency
Private m_cySize As Currency
Private m_ChunkSize As Long
Private m_Buffer() As Byte
Private m_strFilename As String
Private m_StmSource As IStream

Sub Create(Source As IStream, ByVal StartOffset As Currency, ByVal EndOffset As Currency, Optional ByVal YourFileName As String = vbNullString, Optional ByVal sDecryptKey As String = vbNullString)

Set m_StmSource = Source.Clone
m_cyStartOffset = StartOffset \ 10000 'relative to stream
m_cyEndOffset = EndOffset \ 10000 'relative to stream
m_cySize = m_cyEndOffset - m_cyStartOffset
m_cyCurOffset = 0 'relative to ourselves
m_strFilename = YourFileName

If sDecryptKey <> vbNullString Then
    m_bCryptKey = StrConv(sDecryptKey, vbFromUnicode)
End If

End Sub


Private Sub XOR_Decrypt(arr() As Byte, cbSize As Long)
Dim i As Long
For i = 0 To cbSize - 1
    arr(i) = arr(i) Xor m_bCryptKey(m_lngCryptIndex)
    m_lngCryptIndex = (m_lngCryptIndex + 1) Mod 42
Next

End Sub
        
Private Sub Class_Initialize()
    m_ChunkSize = 65536
    ReDim m_Buffer(0 To m_ChunkSize - 1)
    m_bCryptKey = StrConv("UIERYQWORTWEHLKDNKDBISGLZNCBZCVNBADFIEYLJ" & Chr$(0), vbFromUnicode)
End Sub

Private Function IStream_Clone() As olelib2.IStream
    Set IStream_Clone = m_StmSource.Clone
End Function

Private Sub IStream_Commit(ByVal grfCommitFlags As olelib.STGC)
    m_StmSource.Commit grfCommitFlags
    
End Sub

Private Sub IStream_CopyTo(ByVal pstm As olelib2.IStream, ByVal cb As Currency, pcbRead As Currency, pcbWritten As Currency)
    Dim lngRequested As Long
    Dim lngRead As Long
    Dim lngWritten As Long
    'Remember the ULARGE_INTEGER format of cb
    lngRequested = cb * 10000
    If m_ChunkSize <> lngRequested Then
        m_ChunkSize = lngRequested
        ReDim m_Buffer(0 To m_ChunkSize - 1)
    End If
    'Request data from the source, and record number of bytes we actually
    'got
    lngRead = m_StmSource.Read(m_Buffer(0), m_ChunkSize)
    'Decrypt that number of bytes. The decryption routine
    'keeps track of where it is.
    XOR_Decrypt m_Buffer, lngRead
    'pass them on
    pstm.Write m_Buffer(0), lngRead, lngWritten
    'update our internal offset
    m_cyCurOffset = m_cyCurOffset + (CCur(lngRead) / 10000)
    'Report back through byRef params
    pcbRead = lngRead / 10000
    pcbWritten = lngWritten / 10000
    
End Sub

Private Sub IStream_LockRegion(ByVal libOffset As Currency, ByVal cb As Currency, ByVal dwLockType As Long)

End Sub

Private Sub IStream_Read(ByVal pv As Long, ByVal cb As Long, pcbRead As Long)
    Dim lngRead As Long
    If m_ChunkSize <> cb Then
        m_ChunkSize = cb
        ReDim m_Buffer(0 To m_ChunkSize - 1)
    End If
    'Get as much of that as the source is willing to give
    lngRead = m_StmSource.Read(m_Buffer(0), m_ChunkSize)
    'Decrypt what we got
    XOR_Decrypt m_Buffer, lngRead
    'And push it where it was supposed to go
    CopyMemory ByVal pv, m_Buffer(0), lngRead
    'Update our internal position
    m_cyCurOffset = m_cyCurOffset + (CCur(lngRead) / 10000)
End Sub

Private Sub IStream_Revert()
    'Does not apply
    'TODO: Raise read-only error
End Sub

Private Sub IStream_Seek(ByVal dlibMove As Currency, ByVal dwOrigin As olelib.STREAM_SEEK, plibNewPosition As Currency)
    'The trick here is to get the decrypt index right when we
    'jump around in the file. If we mess up, we produce garbage.
    'Also, we must keep in mind that we represent an autonomous subset of the source
    'stream, so we cannot forward seek requests verbatim.
    Dim cyNewPos As Currency
    
    'Then we decide where the next decode byte should come from
    Select Case dwOrigin
    Case STREAM_SEEK_SET
        'easiest case: from the start
        'Add our own offet to the mix, to get things right
        cyNewPos = m_StmSource.Seek(m_cyStartOffset + dlibMove, dwOrigin)
        'When reporting back, subtract our own offset
        plibNewPosition = cyNewPos - m_cyStartOffset
        'And, figure out where we are at cryptographically
        m_lngCryptIndex = (dlibMove * 10000) Mod 42
    Case STREAM_SEEK_CUR
        'from current positon
        cyNewPos = m_StmSource.Seek(dlibMove, dwOrigin)
        m_lngCryptIndex = ((dlibMove * 10000) + m_lngCryptIndex) Mod 42
        plibNewPosition = cyNewPos - m_cyStartOffset
    Case STREAM_SEEK_END
        'Relative to ourselves, remember? We might be in the middle of the
        'source stream. So we do absolute seeking on the  source, passing in
        'the parameters with which we were created
        cyNewPos = m_StmSource.Seek(m_cyEndOffset - dlibMove, STREAM_SEEK_SET)
        m_lngCryptIndex = (m_cySize - dlibMove) Mod 42
        'report back.
        plibNewPosition = cyNewPos - m_cyStartOffset
    End Select
        
End Sub

Private Sub IStream_SetSize(ByVal libNewSize As Currency)
    'Does not apply
End Sub

Private Sub IStream_Stat(pstatstg As olelib.STATSTG, ByVal grfStatFlag As olelib.STATFLAG)
    'Pass on the request to the source
    m_StmSource.Stat pstatstg, grfStatFlag
    With pstatstg
        .cbSize = m_cySize
    End With
End Sub

Private Sub IStream_UnlockRegion(ByVal libOffset As Currency, ByVal cb As Currency, ByVal dwLockType As Long)
    '
End Sub

Private Sub IStream_Write(ByVal pv As Long, ByVal cb As Long, pcbWritten As Long)
    '
End Sub
