VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cFileEntry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Public Enum CompressionMethodEnum
    eeCompNone = 0
    eeCompZlib = 1
    eeCompUnknown = &HFFFF
End Enum
Public Enum EncryptionMethodEnum
    eeEncryptNone = 0
    eeEncryptXOR = 1
    eeEncryptDIVO = 2
End Enum
Public Enum FileEntryEnum
    eeUnknown
    eeFile
    eeFolder
End Enum
Public HeaderVersion As Integer     'for debugging purposes
Public ParentFileName As String     'for debugging
Public fnlen As Currency
Public Name As String               'Filename only
Public Start As Currency            'Start offset in archive, if any
Public Finish As Currency           'End offset in archive, if any
Public Size As Currency             'uncompressed size
Public SizeCompressed As Currency   'compressed size
Public Attributes As Long           'File attributes
Public Path As String               'source path, if any
Public Comments As String           'comments, if any
Public Properties As Collection     'Catch-all repository of property data
Private m_Type As FileEntryEnum     'type of file or folder
Private m_Compression As CompressionMethodEnum 'compression method used
Private m_Encryption As EncryptionMethodEnum   'Encryption method used
Private m_MD5 As Variant
Public Property Get FileItemType() As FileEntryEnum
    FileItemType = m_Type
End Property
Public Property Let FileItemType(ByVal rhs As FileEntryEnum)
    m_Type = rhs
End Property
Public Property Get Compression() As CompressionMethodEnum
    Compression = m_Compression
End Property
Public Property Let Compression(ByVal rhs As CompressionMethodEnum)
    m_Compression = rhs
End Property
Public Property Get Encryption() As EncryptionMethodEnum
    Encryption = m_Encryption
End Property
Public Property Let Encryption(ByVal rhs As EncryptionMethodEnum)
    m_Encryption = rhs
End Property
Public Property Get IsEncrypted() As Boolean
    IsEncrypted = (m_Encryption <> 0)
End Property
Public Property Get IsCompressed() As Boolean
    If Finish = 0 Then
        'not part of an archive
        IsCompressed = False
    Else
        If (Finish - Start) <> Size Then
            IsCompressed = True
        End If
    End If
End Property
Public Property Get IsExtractable() As Boolean
    If (Start > 0) And (Finish > Start) And (m_Compression <> eeCompUnknown) Then
        IsExtractable = True
    Else
        'Must allow for zero-size files
        If Me.Size = 0 Then
            If Me.SizeCompressed = 0 Then
                IsExtractable = True
            End If
        End If
    End If
End Property
Public Property Let MD5Sum(ByVal rhs As Variant)
    m_MD5 = rhs
End Property
Public Property Get MD5Sum() As Variant
    MD5Sum = m_MD5
End Property
Private Sub Class_Initialize()
    Set Properties = New Collection
    m_Type = eeFile 'assume this until further notice.
End Sub
